/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AttrDef Definitions                                                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_ATTRDEF_LIST
#undef GET_ATTRDEF_LIST

::mlir::polynomial::PolynomialAttr,
::mlir::polynomial::RingAttr

#endif  // GET_ATTRDEF_LIST

#ifdef GET_ATTRDEF_CLASSES
#undef GET_ATTRDEF_CLASSES

static ::mlir::OptionalParseResult generatedAttributeParser(::mlir::AsmParser &parser, ::llvm::StringRef *mnemonic, ::mlir::Type type, ::mlir::Attribute &value) {
  return ::mlir::AsmParser::KeywordSwitch<::mlir::OptionalParseResult>(parser)
    .Case(::mlir::polynomial::PolynomialAttr::getMnemonic(), [&](llvm::StringRef, llvm::SMLoc) {
      value = ::mlir::polynomial::PolynomialAttr::parse(parser, type);
      return ::mlir::success(!!value);
    })
    .Case(::mlir::polynomial::RingAttr::getMnemonic(), [&](llvm::StringRef, llvm::SMLoc) {
      value = ::mlir::polynomial::RingAttr::parse(parser, type);
      return ::mlir::success(!!value);
    })
    .Default([&](llvm::StringRef keyword, llvm::SMLoc) {
      *mnemonic = keyword;
      return std::nullopt;
    });
}

static ::mlir::LogicalResult generatedAttributePrinter(::mlir::Attribute def, ::mlir::AsmPrinter &printer) {
  return ::llvm::TypeSwitch<::mlir::Attribute, ::mlir::LogicalResult>(def)    .Case<::mlir::polynomial::PolynomialAttr>([&](auto t) {
      printer << ::mlir::polynomial::PolynomialAttr::getMnemonic();
t.print(printer);
      return ::mlir::success();
    })
    .Case<::mlir::polynomial::RingAttr>([&](auto t) {
      printer << ::mlir::polynomial::RingAttr::getMnemonic();
t.print(printer);
      return ::mlir::success();
    })
    .Default([](auto) { return ::mlir::failure(); });
}

namespace mlir {
namespace polynomial {
namespace detail {
struct PolynomialAttrStorage : public ::mlir::AttributeStorage {
  using KeyTy = std::tuple<Polynomial>;
  PolynomialAttrStorage(Polynomial polynomial) : polynomial(std::move(polynomial)) {}

  KeyTy getAsKey() const {
    return KeyTy(polynomial);
  }

  bool operator==(const KeyTy &tblgenKey) const {
    return (polynomial == std::get<0>(tblgenKey));
  }

  static ::llvm::hash_code hashKey(const KeyTy &tblgenKey) {
    return ::llvm::hash_combine(std::get<0>(tblgenKey));
  }

  static PolynomialAttrStorage *construct(::mlir::AttributeStorageAllocator &allocator, KeyTy &&tblgenKey) {
    auto polynomial = std::move(std::get<0>(tblgenKey));
    return new (allocator.allocate<PolynomialAttrStorage>()) PolynomialAttrStorage(std::move(polynomial));
  }

  Polynomial polynomial;
};
} // namespace detail
PolynomialAttr PolynomialAttr::get(::mlir::MLIRContext *context, Polynomial polynomial) {
  return Base::get(context, std::move(polynomial));
}

Polynomial PolynomialAttr::getPolynomial() const {
  return getImpl()->polynomial;
}

} // namespace polynomial
} // namespace mlir
MLIR_DEFINE_EXPLICIT_TYPE_ID(::mlir::polynomial::PolynomialAttr)
namespace mlir {
namespace polynomial {
namespace detail {
struct RingAttrStorage : public ::mlir::AttributeStorage {
  using KeyTy = std::tuple<Type, IntegerAttr, PolynomialAttr>;
  RingAttrStorage(Type coefficientType, IntegerAttr coefficientModulus, PolynomialAttr polynomialModulus) : coefficientType(std::move(coefficientType)), coefficientModulus(std::move(coefficientModulus)), polynomialModulus(std::move(polynomialModulus)) {}

  KeyTy getAsKey() const {
    return KeyTy(coefficientType, coefficientModulus, polynomialModulus);
  }

  bool operator==(const KeyTy &tblgenKey) const {
    return (coefficientType == std::get<0>(tblgenKey)) && (coefficientModulus == std::get<1>(tblgenKey)) && (polynomialModulus == std::get<2>(tblgenKey));
  }

  static ::llvm::hash_code hashKey(const KeyTy &tblgenKey) {
    return ::llvm::hash_combine(std::get<0>(tblgenKey), std::get<1>(tblgenKey), std::get<2>(tblgenKey));
  }

  static RingAttrStorage *construct(::mlir::AttributeStorageAllocator &allocator, KeyTy &&tblgenKey) {
    auto coefficientType = std::move(std::get<0>(tblgenKey));
    auto coefficientModulus = std::move(std::get<1>(tblgenKey));
    auto polynomialModulus = std::move(std::get<2>(tblgenKey));
    return new (allocator.allocate<RingAttrStorage>()) RingAttrStorage(std::move(coefficientType), std::move(coefficientModulus), std::move(polynomialModulus));
  }

  Type coefficientType;
  IntegerAttr coefficientModulus;
  PolynomialAttr polynomialModulus;
};
} // namespace detail
RingAttr RingAttr::get(::mlir::MLIRContext *context, Type coefficientType, IntegerAttr coefficientModulus, PolynomialAttr polynomialModulus) {
  return Base::get(context, std::move(coefficientType), std::move(coefficientModulus), std::move(polynomialModulus));
}

Type RingAttr::getCoefficientType() const {
  return getImpl()->coefficientType;
}

IntegerAttr RingAttr::getCoefficientModulus() const {
  return getImpl()->coefficientModulus;
}

PolynomialAttr RingAttr::getPolynomialModulus() const {
  return getImpl()->polynomialModulus;
}

} // namespace polynomial
} // namespace mlir
MLIR_DEFINE_EXPLICIT_TYPE_ID(::mlir::polynomial::RingAttr)
namespace mlir {
namespace polynomial {

/// Parse an attribute registered to this dialect.
::mlir::Attribute PolynomialDialect::parseAttribute(::mlir::DialectAsmParser &parser,
                                      ::mlir::Type type) const {
  ::llvm::SMLoc typeLoc = parser.getCurrentLocation();
  ::llvm::StringRef attrTag;
  {
    ::mlir::Attribute attr;
    auto parseResult = generatedAttributeParser(parser, &attrTag, type, attr);
    if (parseResult.has_value())
      return attr;
  }
  
  parser.emitError(typeLoc) << "unknown attribute `"
      << attrTag << "` in dialect `" << getNamespace() << "`";
  return {};
}
/// Print an attribute registered to this dialect.
void PolynomialDialect::printAttribute(::mlir::Attribute attr,
                         ::mlir::DialectAsmPrinter &printer) const {
  if (::mlir::succeeded(generatedAttributePrinter(attr, printer)))
    return;
  
}
} // namespace polynomial
} // namespace mlir

#endif  // GET_ATTRDEF_CLASSES

